hdu 1242 Rescue(bfs+优先队列)

Rescue

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 11533    Accepted Submission(s): 4197


Problem Description
Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison.

Angel's friends want to save Angel. Their task is: approach Angel. We assume that "approach Angel" is to get to the position where Angel stays. When there's a guard in the grid, we must kill him (or her?) to move into the grid. We assume that we moving up, down, right, left takes us 1 unit time, and killing a guard takes 1 unit time, too. And we are strong enough to kill all the guards.

You have to calculate the minimal time to approach Angel. (We can move only UP, DOWN, LEFT and RIGHT, to the neighbor grid within bound, of course.)

Input
First line contains two integers stand for N and M.

Then N lines follows, every line has M characters. "." stands for road, "a" stands for Angel, and "r" stands for each of Angel's friend.

Process to the end of the file.

Output
For each test case, your program should output a single integer, standing for the minimal time needed. If such a number does no exist, you should output a line containing "Poor ANGEL has to stay in the prison all his life."

Sample Input
  
  
7 8 #.#####. #.a#..r. #..#x... ..#..#.# #...##.. .#...... ........

Sample Output
  
  
13

Author
CHEN, Xue

Source

Recommend
Eddy
 
 
 
代码:
#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;

int vis[205][205];
char maps[205][205];   //char啊!!!
int dx[]={-1,1,0,0};
int dy[]={0,0,-1,1};
int ax,ay;
int ans;
int m,n;

struct node
{
    int x;
    int y;
    int value;
    bool operator <(const node &a)const    //所需时间大的优先级小
    {
        return value>a.value;
    }
};

bool isok(node &a)
{
    if(a.x<m&&a.x>=0&&a.y>=0&&a.y<n&&maps[a.x][a.y]!='#')
        return true;
    return false;
}

void bfs()
{
    node cur,tmp;
    cur.x=ax;
    cur.y=ay;
	cur.value=0;
    vis[ax][ay]=1;
    priority_queue<node> q;
    //while(!q.empty())
        //q.pop();
    q.push(cur);
    while(!q.empty())
    {
       cur=q.top();
       q.pop();
       for(int i=0;i<4;i++)
       {
		   tmp=cur;
           int xx=tmp.x+dx[i];
           int yy=tmp.y+dy[i];
           if(!isok(tmp)||vis[xx][yy])
                continue;
           else
           {
			    tmp.x=xx;
				tmp.y=yy;
				vis[xx][yy]=1;
                if(maps[xx][yy]=='x')
					tmp.value+=2;
                else /*if(maps[tmp.x][tmp.y]=='.')*/
					tmp.value+=1;
				if(maps[tmp.x][tmp.y]=='r')
				{
                    printf("%d\n",tmp.value);
					return;
				}
                q.push(tmp);
            }
        }
    }
    printf("Poor ANGEL has to stay in the prison all his life.\n");
}

int main()
{
    int i,j;
    while(scanf("%d%d",&m,&n)!=EOF)
    {
		getchar();
		memset(vis,0,sizeof(vis));
		memset(maps,0,sizeof(maps));
        for(i=0;i<m;i++)
            scanf("%s",maps[i]);
        for(i=0;i<m;i++)
		{
            for(j=0;j<n;j++)
            {
                if(maps[i][j]=='a')
                {
                    ax=i;
                    ay=j;
                }
            }
			//getchar();
		}
		
        bfs();
    }
    return 0;
}

//队列在子函数中定义不需要清空

 
题意:
天使被关在牢里,要她的朋友来拯救她。。。牢房里有路,有看守。碰到看守要花一分钟的时间杀掉,每走一步又要花一分钟。
问她的朋友救到她所需的最小时间。   注意:她可能有多个朋友。
 
分析:
由于可能有多个朋友,所以从天使着手倒着搜,让她去找她的朋友。碰到看守value+=2,否则就+1。找到以后就输出value。
 
注意:
1、如果是直接用scanf("%c",&a);读入数据,两重循环中每一列读完了要用getchar()过滤掉回车。
      但是,如果是先用scanf("%s",a[])读入以后再处理就不用getchar()。
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)加入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别加上a[i],然后再将加和的结果作为新的候选值加入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有加和结果作为新的候选值加入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值